#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

#ifdef __DJ_size_t
#define SPIIDI 1000
#include <allegro.h>
volatile long long Ajastus=0;
void Ajastin(void){Ajastus++;}
END_OF_FUNCTION(Ajastin);
#define gettimeofday(a, b) \
   {register long long c = Ajastus; \
    (a)->tv_sec  = c/SPIIDI;  \
    (a)->tv_usec = (c%SPIIDI)*1000000L/SPIIDI; }
#else
static __inline__ unsigned char inportb(const unsigned short port)
{
   unsigned char _v;
   __asm__ volatile ("inb %1,%0"
             :"=a" (_v):"d" ((unsigned short) port));
   return _v;
}
static __inline__ void outportb(const unsigned short port,
                const unsigned char value)
{
   __asm__ volatile ("outb %0,%1"
             ::"a" ((char) value),"d" ((unsigned short) port));
}
#endif
int rawspeed;
int getmhz(void)
{
    struct timeval tv1,tv2;
    unsigned long long a,b;
    int i;
    volatile int j;
    
    /* At least here must be written one space character */
    printf(" *Wait*");
    fflush(stdout);

    gettimeofday(&tv1, NULL);
    __asm__ __volatile__ ("rdtsc"
        :"=a" (((unsigned long*)&a)[0]),
         "=d" (((unsigned long*)&a)[1]));
    for (j=0; j<40000000; j++); /* 2000ms on a P5-100 */
    gettimeofday(&tv2, NULL);
    __asm__ __volatile__ ("rdtsc"
        :"=a" (((unsigned long*)&b)[0]),
         "=d" (((unsigned long*)&b)[1]));

    printf("\b\b\b\b\b\b");

    b -= a;
    a = (tv2.tv_sec*1000000 + tv2.tv_usec) -
        (tv1.tv_sec*1000000 + tv1.tv_usec);
    // Nyt b=cyclejen mr, a=mikrosekuntimr
    /* how to round? standard clock speeds are usually the
     * multiples of 30 and 33.333, plus 75. Some people
     * use non-standard clock values (like 208) by fiddling with
     * the motherboard jumpers: but we hope they are smart enough
     * to read the READMEs and set their right speed in dosemu.conf.
     * OTOH, I'm not smart enough to come up with a better
     * algorithm  --AV
     */
    rawspeed = (int)(b/a);
    for (i=67; i<=300; i+=33) {
      if ((i%10)==6) i++;   // 133,167,200...
      if (abs(rawspeed-i)<3) return i;
    }
    for (i=60; i<=300; i+=(i>=90? 30:15)) {
      if (abs(rawspeed-i)<3) return i;
    }
    for (i=100; i<=600; i+=50) if (abs(rawspeed-i)<(3+i/100)) return i;
    return rawspeed;
}

long a;

struct timeval gaa, gaa2, Total;

#define START(S...) { int Len; { \
	register int _c; \
	Len = 65-printf(S); \
	printf(" ["); for(_c=0; _c<Len; _c++)printf(" "); \
	printf("]"); for(_c=0; _c<=Len; _c++)printf("\b"); \
    fflush(stdout); gettimeofday(&gaa, NULL); }
#define _IDL(n) if((a%(n/Len))==(n/Len-1))PUT(".")
#define LOOP(n) for(a=0; a<n; a++) {_IDL(n){
#define TODO(n, S...) printf("%-10ld ", (long)n); START(S); LOOP(n)
#define DONE }} \
	gettimeofday(&gaa2, NULL); \
	gaa2.tv_sec -= gaa.tv_sec; \
	gaa2.tv_usec -= gaa.tv_usec; \
	if(gaa2.tv_usec < 0) gaa2.tv_sec--, gaa2.tv_usec += 1000000; \
	printf("\nTime used: %ld.%06ld seconds\n", gaa2.tv_sec, gaa2.tv_usec); \
	Total.tv_sec += gaa2.tv_sec; \
	Total.tv_usec += gaa2.tv_usec; \
    if(Total.tv_usec > 1000000){Total.tv_sec++;Total.tv_usec-=1000000;}}

#define PUT(S...) {printf(S);fflush(stdout);}

int main(void)
{
	time_t t = time(NULL);
	printf("%16s, compiled %s...\n", __FILE__, __DATE__" "__TIME__);
	printf("REPETITIVE SPEED TESTS %sFOR SINGLE PROCESSOR (NO CACHE TEST)\n", ctime(&t));
	
	if(nice(-100) < 0)perror("nice() call failed");
	
    #ifdef __DJ_size_t
    allegro_init();
    switch(os_type)
    {
        case OSTYPE_WIN3:
            printf("Warning: Windows 3.1 or earlier detected, version %d.%d\n", windows_version,windows_sub_version);
            break;
        case OSTYPE_WIN95:
            printf("Warning: Windows 95 or Windows 98 detected, version %d.%d\n", windows_version,windows_sub_version);
            break;  
        case OSTYPE_WINNT:
            printf("Warning: Windows NT detected, version %d.%d\n", windows_version,windows_sub_version);
            break;
        case OSTYPE_OS2:
            printf("Warning: OS/2 detected.\n");
            break;
        case OSTYPE_WARP:
            printf("Warning: OS/2 Warp 3 detected.\n");
            break;
        case OSTYPE_DOSEMU:
            printf("Warning: DOSEMU detected.\n");
            break;
        case OSTYPE_OPENDOS:
            printf("Caldera OpenDOS detected.\n");
            break;
    }
    check_cpu();
    printf("Detected %s ", cpu_vendor);
    switch(cpu_family)
    {
        case 3:
            printf("80386");
            switch(cpu_model)
            {
                case 0: printf("DX"); break;
                case 2: printf("SX"); break;
                case 4: printf("SL");
            }
            break;
        case 4:
            printf("i486");
            switch(cpu_model)
            {
                case 1:
                case 0: printf("DX"); break;
                case 2: printf("SX"); break;
                case 5: printf("SX2"); break;
                case 7: printf("DX2"); break;
                case 8: printf("DX4"); break;
                case 14: printf("\r\r\r\rCyrix 486");
            }
            break;
        case 5:
            printf("Pentium");
            switch(cpu_model)
            {
                case 2: printf(" P54C"); break;
                case 3: printf(" Overdrive"); break;
                case 5: printf(" Overdrive for IntelDX4"); break;
                case 14: printf(" Cyrix"); break;
            }
            break;
        case 6:
            if(cpu_model == 14)
                printf("Pentium II");
            else
                printf("PPro (Model no %d)", cpu_model);
            break;
        default:
            printf("%d86 (unknown)" , cpu_family);
    }
    if(cpu_mmx)printf(" MMX");
    if(!cpu_cpuid)printf(" (Not reliable information)");
    i_love_bill=TRUE;
    LOCK_FUNCTION(Ajastin);
    LOCK_VARIABLE(Ajastus);
    install_timer();
    install_int_ex(Ajastin, BPS_TO_TIMER(SPIIDI));
    #else
    iopl(3);
    printf("CPU speed measured as"); 
    #endif
    fflush(stdout);
    printf("%d MHz. Now starting the tests.\n\n", getmhz());
	
    Total.tv_sec = Total.tv_usec = 0;
	
    TODO(20000000, "Testing empty loop")
	DONE
	
    TODO(10000000, "Testing 0x3BC port input speed")
		inportb(0x3BC);
	DONE
	
    TODO(10000000, "Testing 0x278 port input speed")
		inportb(0x278);
	DONE
	
    TODO(10000000, "Testing 0x6100 port input speed")
		inportb(0x6100);
	DONE
	
    TODO(10000000, "Testing 0x60 port input speed")
		inportb(0x60);
	DONE
	
    TODO(400000, "Testing VGA IO speed (your screen can shake now)")
		int b, VGA[4];
		for(b=11; b<15; b++)
		{
			outportb(0x3D4, b); VGA[b-11] = inportb(0x3D5);
			outportb(0x3D4, b); outportb(0x3D5, a);
		}
		for(b=11; b<15; b++)
		{
			outportb(0x3D4, b); outportb(0x3D5, VGA[b-11]);
		}
	DONE
	
	TODO(20000000, "Testing integer operations")

        static int b, c;
	
		c = (b*50+c)/3;
		b = c/10 - 40;
        c = ((b^0x1000457) + (c|0xB0000)) >> 18;
		
	DONE
	
	TODO(10000000, "Testing fpu operations (float, basic operations)")

        static float d, e;
	
		d = (e + 0.04) * d - 0.04155;
		e = d+0.1;
		e=d = d*e / 7.21E50;
		
	DONE
	
	TODO(10000000, "Testing fpu more... (float, advanced operations)")

        static float d, e;
		
        d = sin(e+0.01);
		e = cos(d) * sqrt(fabs(d));
		
	DONE
	
	
	TODO(10000000, "More... (double, basic operations)")

        static double h, j;
	
		h = (j + 0.04) * h - 0.04155;
		j = h+0.1;
		j=h = h*j / 7.21E50;
		
	DONE
	
	TODO(10000000, "Yep... (double, advanced operations)")

        static double h, j;
		
        h = sin(j+0.01);
		j = cos(h) * sqrt(fabs(h));
		
	DONE
	
/*
	TODO(10000000, "Hmm... (long double, basic operations)")

        static long double H, J;
	
		H = (J + 0.04) * H - 0.04155;
		J = H+0.1;
		J=H = H*J / 7.21E50;
		
	DONE
	
	TODO(10000000, "Mmh. (long double, advanced operations)")
		
        static long double H, J;
	
        H = sin(J+0.01);
		J = cos(H) * sqrt(fabs(H));
		
	DONE
*/
	printf("\nTotal time used: %ld.%06ld seconds\n", Total.tv_sec, Total.tv_usec);

    #ifdef __DJ_size_t
    allegro_exit();
    #endif

    printf("This program has been written by Bisqwit.\n");
    
    return 0;
}
